#!/usr/bin/env python
# -*- Mode: Python -*-
# 
#  ***** BEGIN LICENSE BLOCK *****  
#   
#  Source last modified: $Id: pylink_exe.py,v 1.2 2006/07/06 19:28:05 jfinnecy Exp $ 
#   
#  Copyright Notices: 
#   
#  Portions Copyright (c) 1995-2006 RealNetworks, Inc. All Rights Reserved. 
#   
#  Patent Notices: This file may contain technology protected by one or  
#  more of the patents listed at www.helixcommunity.org 
#   
#  1.   The contents of this file, and the files included with this file, 
#  are protected by copyright controlled by RealNetworks and its  
#  licensors, and made available by RealNetworks subject to the current  
#  version of the RealNetworks Public Source License (the "RPSL")  
#  available at  * http://www.helixcommunity.org/content/rpsl unless  
#  you have licensed the file under the current version of the  
#  RealNetworks Community Source License (the "RCSL") available at 
#  http://www.helixcommunity.org/content/rcsl, in which case the RCSL 
#  will apply.  You may also obtain the license terms directly from 
#  RealNetworks.  You may not use this file except in compliance with 
#  the RPSL or, if you have a valid RCSL with RealNetworks applicable 
#  to this file, the RCSL.  Please see the applicable RPSL or RCSL for 
#  the rights, obligations and limitations governing use of the 
#  contents of the file. 
#   
#  2.  Alternatively, the contents of this file may be used under the 
#  terms of the GNU General Public License Version 2 (the 
#  "GPL") in which case the provisions of the GPL are applicable 
#  instead of those above.  Please note that RealNetworks and its  
#  licensors disclaim any implied patent license under the GPL.   
#  If you wish to allow use of your version of this file only under  
#  the terms of the GPL, and not to allow others 
#  to use your version of this file under the terms of either the RPSL 
#  or RCSL, indicate your decision by deleting Paragraph 1 above 
#  and replace them with the notice and other provisions required by 
#  the GPL. If you do not delete Paragraph 1 above, a recipient may 
#  use your version of this file under the terms of any one of the 
#  RPSL, the RCSL or the GPL. 
#   
#  This file is part of the Helix DNA Technology.  RealNetworks is the 
#  developer of the Original Code and owns the copyrights in the 
#  portions it created.   Copying, including reproducing, storing,  
#  adapting or translating, any or all of this material other than  
#  pursuant to the license terms referred to above requires the prior  
#  written consent of RealNetworks and its licensors 
#   
#  This file, and the files included with this file, is distributed 
#  and made available by RealNetworks on an 'AS IS' basis, WITHOUT  
#  WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, AND REALNETWORKS  
#  AND ITS LICENSORS HEREBY DISCLAIM  ALL SUCH WARRANTIES, INCLUDING  
#  WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY, FITNESS  
#  FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT. 
#   
#  Technology Compatibility Kit Test Suite(s) Location:  
#     http://www.helixcommunity.org/content/tck 
#   
#  Contributor(s):  
#  
#  ***** END LICENSE BLOCK ***** 
# 

import os
import sys
import string
import getopt
import re

import basefile
import dll

def main(args):
    of = None

    newargs = [ ]

    for a in args[1:]:
        al=string.lower(a)

        if al[:10] == "-basefile:":
            datafile = al[10:]
            continue

        if al[:9] == "-basedir:":
            basedir = al[9:]
            continue

        if al[:6] == "/base:":
            newbase = eval(al[6:])
            continue

        if al[:5] == "/out:":
            of = a[5:]

        if al[:9] == "/libpath:":
            libPath = a[9:]

            if (libPath[0] != '\"' and libPath[-1] != '\"'):
                a = "%s\"%s\"" % (a[:9], libPath)

        newargs.append(a)

    if not of:
        print "Failed to find output name!"
        sys.exit(1)

    if not newbase:
        print "Failed to find default base!"
        sys.exit(1)

    dllname = os.path.join(basedir, of)
        
    bf = basefile.Basefile( datafile , newbase )
    bf.lock()
    bf.readData()
    newbase = bf.getNextBaseAddress( dllname )

    ## FIXME: Quoting!!!
    newargs[1:1]=["/BASE:0x%x" % newbase]

    newargs=string.join(newargs)
    print "Pylink, executing link %s" % newargs
    tmpname="pylinktmp-%s" % os.path.splitext(os.path.basename(of))[0]
    open(tmpname,"w").write(newargs)
    ret=os.system("link @%s" % tmpname)
    if ret:
        sys.exit(ret)
    
    myDLL = dll.DLL( of )
    size  = myDLL.getRoundedMemorySize()    
    bf.recordDLL( dllname , newbase , size )
    bf.unlock()
        
def run():
    main( sys.argv )
