/* ***** BEGIN LICENSE BLOCK *****
 * Source last modified: $Id: hxsockcallback.h,v 1.1.36.1 2004/07/09 02:09:00 hubbe Exp $
 * 
 * Portions Copyright (c) 1995-2004 RealNetworks, Inc. All Rights Reserved.
 * 
 * The contents of this file, and the files included with this file,
 * are subject to the current version of the RealNetworks Public
 * Source License (the "RPSL") available at
 * http://www.helixcommunity.org/content/rpsl unless you have licensed
 * the file under the current version of the RealNetworks Community
 * Source License (the "RCSL") available at
 * http://www.helixcommunity.org/content/rcsl, in which case the RCSL
 * will apply. You may also obtain the license terms directly from
 * RealNetworks.  You may not use this file except in compliance with
 * the RPSL or, if you have a valid RCSL with RealNetworks applicable
 * to this file, the RCSL.  Please see the applicable RPSL or RCSL for
 * the rights, obligations and limitations governing use of the
 * contents of the file.
 * 
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL") in which case the provisions of the GPL are applicable
 * instead of those above. If you wish to allow use of your version of
 * this file only under the terms of the GPL, and not to allow others
 * to use your version of this file under the terms of either the RPSL
 * or RCSL, indicate your decision by deleting the provisions above
 * and replace them with the notice and other provisions required by
 * the GPL. If you do not delete the provisions above, a recipient may
 * use your version of this file under the terms of any one of the
 * RPSL, the RCSL or the GPL.
 * 
 * This file is part of the Helix DNA Technology. RealNetworks is the
 * developer of the Original Code and owns the copyrights in the
 * portions it created.
 * 
 * This file, and the files included with this file, is distributed
 * and made available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY
 * KIND, EITHER EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS
 * ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET
 * ENJOYMENT OR NON-INFRINGEMENT.
 * 
 * Technology Compatibility Kit Test Suite(s) Location:
 *    http://www.helixcommunity.org/content/tck
 * 
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */

#ifndef HXSOCKCALLBACK_H
#define HXSOCKCALLBACK_H

#include "hxtypes.h"
#include "hxcom.h"
#include "hxengin.h" // IHXCallback

class SocketCallbackInterface
{
	public:
		virtual STDMETHODIMP HandleCallback(INT32 theCommand, HX_RESULT theError) = 0;
};

class ScheduledSocketCallback : public IHXCallback,
		 	 public IHXInterruptSafe 
{
public:
	SocketCallbackInterface*	m_pSocket;
	CallbackHandle				m_Handle;
	HX_BITFIELD	    			m_bIsCallbackPending : 1;
	HX_BITFIELD	   				m_bInterruptSafe : 1;
	INT32						m_Command;
	HX_RESULT					m_Error;

	ScheduledSocketCallback(SocketCallbackInterface *owner, BOOL interruptSafe);
	/*
	 *	IUnknown methods
	 */
	STDMETHOD(QueryInterface)	(THIS_
					REFIID riid,
					void** ppvObj);

	STDMETHOD_(ULONG32,AddRef)	(THIS);

	STDMETHOD_(ULONG32,Release)	(THIS);

	/*
	 *	IHXCallback methods
	 */
	STDMETHOD(Func)		(THIS);

		/*
	 	 *	IHXInterruptSafe methods
	 	 */
		STDMETHOD_(BOOL,IsInterruptSafe)	(THIS);

	STDMETHOD_(BOOL,ScheduleCallback)	(THIS_
					INT32 				theCommand,
					IHXScheduler*		theScheduler,
					ULONG32 			theTime,
					HX_RESULT			theError = HXR_OK);
					
	INT32 GetCommand(void) { return m_Command; }
	INT32 GetError(void) { return m_Error; }
	
	void  Unschedule(IHXScheduler*		theScheduler);
	
	protected:
		~ScheduledSocketCallback();
		PRIVATE_DESTRUCTORS_ARE_NOT_A_CRIME

	LONG32		m_lRefCount;
	};

#endif /* HXSOCKCALLBACK_H */
