/* ***** BEGIN LICENSE BLOCK *****
 * Source last modified: $Id: dcoreres.h,v 1.2.42.1 2004/07/19 21:03:59 hubbe Exp $
 * 
 * Portions Copyright (c) 1995-2004 RealNetworks, Inc. All Rights Reserved.
 * 
 * The contents of this file, and the files included with this file,
 * are subject to the current version of the RealNetworks Public
 * Source License (the "RPSL") available at
 * http://www.helixcommunity.org/content/rpsl unless you have licensed
 * the file under the current version of the RealNetworks Community
 * Source License (the "RCSL") available at
 * http://www.helixcommunity.org/content/rcsl, in which case the RCSL
 * will apply. You may also obtain the license terms directly from
 * RealNetworks.  You may not use this file except in compliance with
 * the RPSL or, if you have a valid RCSL with RealNetworks applicable
 * to this file, the RCSL.  Please see the applicable RPSL or RCSL for
 * the rights, obligations and limitations governing use of the
 * contents of the file.
 * 
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL") in which case the provisions of the GPL are applicable
 * instead of those above. If you wish to allow use of your version of
 * this file only under the terms of the GPL, and not to allow others
 * to use your version of this file under the terms of either the RPSL
 * or RCSL, indicate your decision by deleting the provisions above
 * and replace them with the notice and other provisions required by
 * the GPL. If you do not delete the provisions above, a recipient may
 * use your version of this file under the terms of any one of the
 * RPSL, the RCSL or the GPL.
 * 
 * This file is part of the Helix DNA Technology. RealNetworks is the
 * developer of the Original Code and owns the copyrights in the
 * portions it created.
 * 
 * This file, and the files included with this file, is distributed
 * and made available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY
 * KIND, EITHER EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS
 * ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET
 * ENJOYMENT OR NON-INFRINGEMENT.
 * 
 * Technology Compatibility Kit Test Suite(s) Location:
 *    http://www.helixcommunity.org/content/tck
 * 
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */

#ifndef _DCORERES_H_
#define _DCORERES_H_

#include "resid.h"

#define IDS_UNKNOWN_STRING              HX_CORE_RES_INIT_ID + 0
#define IDS_ERR_GENERAL_ERROR           HX_CORE_RES_INIT_ID + 1
#define IDS_ERR_MEMORY_ERROR            HX_CORE_RES_INIT_ID + 2
#define IDS_ERR_INVALID_PARAMETER       HX_CORE_RES_INIT_ID + 3
#define IDS_ERR_INVALID_OPERATION       HX_CORE_RES_INIT_ID + 4
#define IDS_ERR_NOT_INITIALIZED_ERROR   HX_CORE_RES_INIT_ID + 5
#define IDS_ERR_INVALID_FILE            HX_CORE_RES_INIT_ID + 6
#define IDS_ERR_INVALID_VERSION         HX_CORE_RES_INIT_ID + 7
#define IDS_ERR_DOC_MISSING_ERROR       HX_CORE_RES_INIT_ID + 8
#define IDS_ERR_FORMAT_ERROR            HX_CORE_RES_INIT_ID + 9
#define IDS_ERR_NET_SOCKET_INVALID      HX_CORE_RES_INIT_ID + 10
#define IDS_ERR_NET_CONNECT_ERROR       HX_CORE_RES_INIT_ID + 11
#define IDS_ERR_BIND_ERROR              HX_CORE_RES_INIT_ID + 12
#define IDS_ERR_SOCKET_CREATE_ERROR     HX_CORE_RES_INIT_ID + 13
#define IDS_ERR_INVALID_HOST            HX_CORE_RES_INIT_ID + 14
#define IDS_ERR_INVALID_PATH            HX_CORE_RES_INIT_ID + 15
#define IDS_ERR_NET_READ_ERROR          HX_CORE_RES_INIT_ID + 16
#define IDS_ERR_NET_WRITE_ERROR         HX_CORE_RES_INIT_ID + 17
#define IDS_ERR_NET_UDP_ERROR           HX_CORE_RES_INIT_ID + 18
#define IDS_ERR_SERVER_TIMEOUT          HX_CORE_RES_INIT_ID + 19
#define IDS_ERR_SERVER_DISCONNECTED     HX_CORE_RES_INIT_ID + 20
#define IDS_ERR_DNR_ERROR               HX_CORE_RES_INIT_ID + 21
#define IDS_ERR_OPEN_DRIVER_ERROR       HX_CORE_RES_INIT_ID + 22
#define IDS_ERR_UPGRADE_ERROR           HX_CORE_RES_INIT_ID + 23
#define IDS_ERR_BAD_SERVER_ERROR        HX_CORE_RES_INIT_ID + 24
#define IDS_ERR_ADVANCED_SERVER_ERROR   HX_CORE_RES_INIT_ID + 25
#define IDS_ERR_OLD_SERVER_ERROR        HX_CORE_RES_INIT_ID + 26
#define IDS_ERR_DEC_NOT_FOUND           HX_CORE_RES_INIT_ID + 27
#define IDS_ERR_DEC_INVALID             HX_CORE_RES_INIT_ID + 28
#define IDS_ERR_DEC_TYPE_MISMATCH       HX_CORE_RES_INIT_ID + 29
#define IDS_ERR_DEC_INIT_FAILED         HX_CORE_RES_INIT_ID + 30
#define IDS_ERR_DEC_NOT_INITED          HX_CORE_RES_INIT_ID + 31
#define IDS_ERR_DEC_DECOMPRESS_ERROR    HX_CORE_RES_INIT_ID + 32
#define IDS_ERR_SERVER_ALERT            HX_CORE_RES_INIT_ID + 33
#define IDS_ERR_PROXY_ERROR             HX_CORE_RES_INIT_ID + 34
#define IDS_ERR_PROXY_RESPONSE_ERROR    HX_CORE_RES_INIT_ID + 35
#define IDS_ERR_ADVANCED_PROXY_ERROR    HX_CORE_RES_INIT_ID + 36
#define IDS_ERR_OLD_PROXY_ERROR         HX_CORE_RES_INIT_ID + 37
#define IDS_ERR_AUDIO_DRIVER_ERROR      HX_CORE_RES_INIT_ID + 38
#define IDS_ERR_INVALID_PROTOCOL_ERROR  HX_CORE_RES_INIT_ID + 39
#define IDS_ERR_INVALID_URL_OPTION_ERROR HX_CORE_RES_INIT_ID + 40
#define IDS_ERR_INVALID_URL_HOST        HX_CORE_RES_INIT_ID + 41
#define IDS_ERR_INVALID_URL_PATH        HX_CORE_RES_INIT_ID + 42
#define IDS_ERR_GENERAL_NONET           HX_CORE_RES_INIT_ID + 43
#define IDS_ERR_NEED_256_COLORS         HX_CORE_RES_INIT_ID + 44
#define IDS_ERR_NOT_NOTIFIED            HX_CORE_RES_INIT_ID + 45
#define IDS_ERR_CLV_NOT_SUPPORTED       HX_CORE_RES_INIT_ID + 46
#define IDS_ERR_CANNOTGOFULLSCREEN      HX_CORE_RES_INIT_ID + 47
#define IDS_ERR_OPEN_NOT_PROCESSED      HX_CORE_RES_INIT_ID + 48
#define IDS_ERR_ADVANCED_PROXY_ERROR2   HX_CORE_RES_INIT_ID + 49
#define IDS_ERR_BLOCK_CANCELED          HX_CORE_RES_INIT_ID + 50
#define IDS_ERR_UPGRADE_NO_RESPONSE     HX_CORE_RES_INIT_ID + 51
#define IDS_ERR_AC_DNS_TIMEOUT          HX_CORE_RES_INIT_ID + 52
#define IDS_ERR_HTTP_NOTAVAIL           HX_CORE_RES_INIT_ID + 53
#define IDS_ERR_HTTP_CONNECT_ERROR      HX_CORE_RES_INIT_ID + 54
#define IDS_ERR_WIN32_INVALID_SOCKET    HX_CORE_RES_INIT_ID + 55
#define IDS_ERR_AUTHENTICATION_FAILED   HX_CORE_RES_INIT_ID + 56
#define IDS_ERR_VFW_NOT_SUPPORTED       HX_CORE_RES_INIT_ID + 57
#define IDS_ERR_PERFECTPLAY_NOT_SUPPORTED HX_CORE_RES_INIT_ID + 58
#define IDS_ERR_NO_LIVE_PERFECTPLAY     HX_CORE_RES_INIT_ID + 59
#define IDS_ERR_NOT_AUTHORIZED          HX_CORE_RES_INIT_ID + 60
#define IDS_ERR_PERFECTPLAY_NOT_ALLOWED HX_CORE_RES_INIT_ID + 61
#define IDS_ERR_INVALID_PROTOCOL        HX_CORE_RES_INIT_ID + 62
#define IDS_ERR_GENERAL_MULTICAST_ERROR HX_CORE_RES_INIT_ID + 63
#define IDS_ERR_MULTICAST_JOIN_ERROR    HX_CORE_RES_INIT_ID + 64
#define IDS_ERR_MULTICAST_UDP_ERROR     HX_CORE_RES_INIT_ID + 65
#define IDS_ERR_NO_CODECS               HX_CORE_RES_INIT_ID + 66
#define IDS_ERR_SLOW_MACHINE            HX_CORE_RES_INIT_ID + 67
#define IDS_ERR_INVALID_HTTP_PROXY_HOST HX_CORE_RES_INIT_ID + 68
#define IDS_ERR_INVALID_METAFILE        HX_CORE_RES_INIT_ID + 69
#define IDS_ERR_BAD_TRANSPORT           HX_CORE_RES_INIT_ID + 72
#define IDS_ERR_UNSUPPORTED_VIDEO       HX_CORE_RES_INIT_ID + 73
#define IDS_ERR_UNSUPPORTED_AUDIO       HX_CORE_RES_INIT_ID + 74
#define IDS_ERR_MISSING_COMPONENTS      HX_CORE_RES_INIT_ID + 75
#define IDS_ERR_TRY_AUTOCONFIG          HX_CORE_RES_INIT_ID + 76
#define IDS_ERR_NOTENOUGH_BANDWIDTH     HX_CORE_RES_INIT_ID + 77
#define IDS_ERR_PROXY_DNR_ERROR		HX_CORE_RES_INIT_ID + 78
#define IDS_ERR_PROXY_NET_CONNECT_ERROR	HX_CORE_RES_INIT_ID + 79
#define IDS_ERR_VIEW_SOURCE_NOCLIP	HX_CORE_RES_INIT_ID + 80
#define IDS_ERR_VIEW_SOURCE_DISSABLED	HX_CORE_RES_INIT_ID + 81
#define IDS_ERR_RIGHTS_EXPIRED		HX_CORE_RES_INIT_ID + 82
#define IDS_ERR_VIEW_RIGHTS_NODRM	HX_CORE_RES_INIT_ID + 83
#define IDS_ERR_CHECK_RIGHTS		HX_CORE_RES_INIT_ID + 84
#define IDS_ERR_RESTORE_SERVER_DENIED	HX_CORE_RES_INIT_ID + 85
#define IDS_ERR_DEBUGGER_DETECTED	HX_CORE_RES_INIT_ID + 86
#define IDS_ERR_RESTORE_SERVER_CONNECT	HX_CORE_RES_INIT_ID + 87
#define IDS_ERR_RESTORE_SERVER_TIMEOUT	HX_CORE_RES_INIT_ID + 88
#define IDS_ERR_REVOKE_SERVER_CONNECT	HX_CORE_RES_INIT_ID + 89
#define IDS_ERR_REVOKE_SERVER_TIMEOUT	HX_CORE_RES_INIT_ID + 90
#define IDS_ERR_RESTORATION_COMPLETE	HX_CORE_RES_INIT_ID + 91
#define IDS_ERR_BACKUP_COMPLETE		HX_CORE_RES_INIT_ID + 92
#define IDS_ERR_TLC_NOT_CERTIFIED	HX_CORE_RES_INIT_ID + 93
#define IDS_ERR_CORRUPTED_BACKUP_FILE	HX_CORE_RES_INIT_ID + 94
#define IDS_ERR_VSRC_DISABLED		HX_CORE_RES_INIT_ID + 95
#define IDS_ERR_VSRC_NOCLIP		HX_CORE_RES_INIT_ID + 96
#define IDS_ERR_VSRC_NODRM		HX_CORE_RES_INIT_ID + 97
#define IDS_ERR_WINDRAW_EXCEPTION	HX_CORE_RES_INIT_ID + 98

#define IDS_STATUS_CONTACTING		HX_CORE_RES_INIT_ID + 200
#endif /* _DCORERES_H_ */
