/* ***** BEGIN LICENSE BLOCK *****
 * Source last modified: $Id: stream_info.h,v 1.1.4.1 2004/11/24 18:02:52 acolwell Exp $
 * 
 * Portions Copyright (c) 1995-2004 RealNetworks, Inc. All Rights Reserved.
 * 
 * The contents of this file, and the files included with this file,
 * are subject to the current version of the RealNetworks Public
 * Source License (the "RPSL") available at
 * http://www.helixcommunity.org/content/rpsl unless you have licensed
 * the file under the current version of the RealNetworks Community
 * Source License (the "RCSL") available at
 * http://www.helixcommunity.org/content/rcsl, in which case the RCSL
 * will apply. You may also obtain the license terms directly from
 * RealNetworks.  You may not use this file except in compliance with
 * the RPSL or, if you have a valid RCSL with RealNetworks applicable
 * to this file, the RCSL.  Please see the applicable RPSL or RCSL for
 * the rights, obligations and limitations governing use of the
 * contents of the file.
 * 
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL") in which case the provisions of the GPL are applicable
 * instead of those above. If you wish to allow use of your version of
 * this file only under the terms of the GPL, and not to allow others
 * to use your version of this file under the terms of either the RPSL
 * or RCSL, indicate your decision by deleting the provisions above
 * and replace them with the notice and other provisions required by
 * the GPL. If you do not delete the provisions above, a recipient may
 * use your version of this file under the terms of any one of the
 * RPSL, the RCSL or the GPL.
 * 
 * This file is part of the Helix DNA Technology. RealNetworks is the
 * developer of the Original Code and owns the copyrights in the
 * portions it created.
 * 
 * This file, and the files included with this file, is distributed
 * and made available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY
 * KIND, EITHER EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS
 * ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET
 * ENJOYMENT OR NON-INFRINGEMENT.
 * 
 * Technology Compatibility Kit Test Suite(s) Location:
 *    http://www.helixcommunity.org/content/tck
 * 
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */
#ifndef STREAM_INFO_H
#define STREAM_INFO_H

#include "codec_info.h"

#include "hxslist.h"

class COggStreamInfo
{
public:
    COggStreamInfo(UINT32 uSerialNum);
    ~COggStreamInfo();

    HX_RESULT OnPage(ogg_page* pPage);

    BOOL HaveHeaders() const;
    BOOL HaveBaseGranulePos() const;

    const COggCodecInfo* CodecInfo() const {return m_pCodecInfo;}
    HX_RESULT SetBaseTimestamp(const COggTimestamp& timestamp);

private:    
    typedef enum {
        Start, 
        WaitingForTSInit,
        Ready} State;

    typedef COggCodecInfo* (*BuildFunc)(ogg_packet* pPkt);

    void changeState(State newState);

    HX_RESULT onPacket(ogg_packet* pPkt);
    HX_RESULT createCodecInfo(ogg_packet* pPkt);

    ogg_stream_state m_os;
    State m_state;

    COggCodecInfo* m_pCodecInfo;
    static const BuildFunc zm_pBuildFuncs[];
};
#endif /* STREAM_INFO_H */
