/* ***** BEGIN LICENSE BLOCK *****
 * Source last modified: $Id: decoder.h,v 1.1.1.1.46.2 2004/07/13 21:00:44 bobclark Exp $
 * 
 * Portions Copyright (c) 1995-2004 RealNetworks, Inc. All Rights Reserved.
 * 
 * The contents of this file, and the files included with this file,
 * are subject to the current version of the RealNetworks Public
 * Source License (the "RPSL") available at
 * http://www.helixcommunity.org/content/rpsl unless you have licensed
 * the file under the current version of the RealNetworks Community
 * Source License (the "RCSL") available at
 * http://www.helixcommunity.org/content/rcsl, in which case the RCSL
 * will apply. You may also obtain the license terms directly from
 * RealNetworks.  You may not use this file except in compliance with
 * the RPSL or, if you have a valid RCSL with RealNetworks applicable
 * to this file, the RCSL.  Please see the applicable RPSL or RCSL for
 * the rights, obligations and limitations governing use of the
 * contents of the file.
 * 
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL") in which case the provisions of the GPL are applicable
 * instead of those above. If you wish to allow use of your version of
 * this file only under the terms of the GPL, and not to allow others
 * to use your version of this file under the terms of either the RPSL
 * or RCSL, indicate your decision by deleting the provisions above
 * and replace them with the notice and other provisions required by
 * the GPL. If you do not delete the provisions above, a recipient may
 * use your version of this file under the terms of any one of the
 * RPSL, the RCSL or the GPL.
 * 
 * This file is part of the Helix DNA Technology. RealNetworks is the
 * developer of the Original Code and owns the copyrights in the
 * portions it created.
 * 
 * This file, and the files included with this file, is distributed
 * and made available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY
 * KIND, EITHER EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS
 * ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET
 * ENJOYMENT OR NON-INFRINGEMENT.
 * 
 * Technology Compatibility Kit Test Suite(s) Location:
 *    http://www.helixcommunity.org/content/tck
 * 
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */

#ifndef _DECODER_H_
#define _DECODER_H_

class CChunkyRes;


/////////////////////////////////////////////////////////////////////////////
// 
//  Class:
//
//  	CDecoder
//
//  Purpose:
//
//  	Decoder for encoded HTTP content.
//

class CDecoder
{
public:
    CDecoder();
    ~CDecoder();

    // Public API
    void	SetOutputSink   (CChunkyRes* pOutputSink);
    HX_RESULT	SetData		(UINT32 ulOffset, 
				 const char* pBuf, 
                                UINT32 ulCount,
                                BOOL bChunkedEncoding = FALSE);
    UINT32	GetContentRead	();

private:
    CChunkyRes*	    m_pOutputSink;
    UINT32	    m_ulSinkPos;
    UINT32	    m_ulInputSpace;
    char*	    m_pInputBuf;
    UINT32	    m_ulInputLen;
    UINT32	    m_ulOutputSpace;
    char*	    m_pOutputBuf;
    BOOL	    m_bHeaderRemoved;
    BOOL	    m_bStarted;
    z_stream	    m_DStream;		// Decompression Stream

    // Helper methods
    HX_RESULT	Reset		();
    HX_RESULT   PrepareBuffers  (const char* pBuf, UINT32 ulCount, BOOL bChunkedEncoding);
    HX_RESULT	SkipHeader	(char* pBuf, 
				 UINT32 ulCount, 
                                BOOL bChunkedEncoding,
				 REF(char*)pNewBuf);
    HX_RESULT	DecodeData	();
};

#endif
