/* ***** BEGIN LICENSE BLOCK *****
 * Source last modified: $Id: uninstdefs.h,v 1.1.2.1 2004/07/09 02:03:10 hubbe Exp $
 * 
 * Portions Copyright (c) 1995-2004 RealNetworks, Inc. All Rights Reserved.
 * 
 * The contents of this file, and the files included with this file,
 * are subject to the current version of the RealNetworks Public
 * Source License (the "RPSL") available at
 * http://www.helixcommunity.org/content/rpsl unless you have licensed
 * the file under the current version of the RealNetworks Community
 * Source License (the "RCSL") available at
 * http://www.helixcommunity.org/content/rcsl, in which case the RCSL
 * will apply. You may also obtain the license terms directly from
 * RealNetworks.  You may not use this file except in compliance with
 * the RPSL or, if you have a valid RCSL with RealNetworks applicable
 * to this file, the RCSL.  Please see the applicable RPSL or RCSL for
 * the rights, obligations and limitations governing use of the
 * contents of the file.
 * 
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL") in which case the provisions of the GPL are applicable
 * instead of those above. If you wish to allow use of your version of
 * this file only under the terms of the GPL, and not to allow others
 * to use your version of this file under the terms of either the RPSL
 * or RCSL, indicate your decision by deleting the provisions above
 * and replace them with the notice and other provisions required by
 * the GPL. If you do not delete the provisions above, a recipient may
 * use your version of this file under the terms of any one of the
 * RPSL, the RCSL or the GPL.
 * 
 * This file is part of the Helix DNA Technology. RealNetworks is the
 * developer of the Original Code and owns the copyrights in the
 * portions it created.
 * 
 * This file, and the files included with this file, is distributed
 * and made available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY
 * KIND, EITHER EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS
 * ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET
 * ENJOYMENT OR NON-INFRINGEMENT.
 * 
 * Technology Compatibility Kit Test Suite(s) Location:
 *    http://www.helixcommunity.org/content/tck
 * 
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */
#ifndef _UNINSTDEFS_H_
#define _UNINSTDEFS_H_

// Install item directives
#define UNINST_TITLE        "Title"
#define UNINST_REGKEY       "Reg Key"
#define UNINST_REGNAME      "Reg Name"
#define UNINST_REGVALUE     "Reg Val"
#define UNINST_REGTREE      "Reg Tree"
#define UNINST_DIRECTORY    "Directory"
#define UNINST_FILE         "File"
#define UNINST_MULTIFILE    "Multiple Files"
#define UNINST_SHFILE       "Shared File"
#define UNINST_SERVICE      "Service"
#define UNINST_APP_PATH     "App Path"

// Registry keys
#define SZ_SHARED_FILES_KEY "SOFTWARE\\Microsoft\\Windows\\CurrentVersion" \
                            "\\SharedDLLs"

// Key mapping, from strings to predefined root keys
typedef struct
{
    const char* szName;
    HKEY hkey;
} SHKEYValMap;

const SHKEYValMap HKEY_MAP[] = {
        { "HKEY_CLASSES_ROOT", HKEY_CLASSES_ROOT },
        { "HKEY_LOCAL_MACHINE", HKEY_LOCAL_MACHINE },
        { "HKEY_CURRENT_USER", HKEY_CURRENT_USER },
        { "HKEY_USERS", HKEY_USERS },
        { "HKEY_CURRENT_CONFIG", HKEY_CURRENT_CONFIG },
        { "HKEY_PERFORMANCE_DATA", HKEY_PERFORMANCE_DATA },
        { "HKEY_DYN_DATA", HKEY_DYN_DATA }, 
        { 0, 0 } };


#endif // _UNINSTDEFS_H_
