/* ***** BEGIN LICENSE BLOCK *****
 * Source last modified: $Id: ihxappinfo.h,v 1.3.4.3 2004/07/09 01:48:38 hubbe Exp $
 * 
 * Portions Copyright (c) 1995-2004 RealNetworks, Inc. All Rights Reserved.
 * 
 * The contents of this file, and the files included with this file,
 * are subject to the current version of the RealNetworks Public
 * Source License (the "RPSL") available at
 * http://www.helixcommunity.org/content/rpsl unless you have licensed
 * the file under the current version of the RealNetworks Community
 * Source License (the "RCSL") available at
 * http://www.helixcommunity.org/content/rcsl, in which case the RCSL
 * will apply. You may also obtain the license terms directly from
 * RealNetworks.  You may not use this file except in compliance with
 * the RPSL or, if you have a valid RCSL with RealNetworks applicable
 * to this file, the RCSL.  Please see the applicable RPSL or RCSL for
 * the rights, obligations and limitations governing use of the
 * contents of the file.
 * 
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL") in which case the provisions of the GPL are applicable
 * instead of those above. If you wish to allow use of your version of
 * this file only under the terms of the GPL, and not to allow others
 * to use your version of this file under the terms of either the RPSL
 * or RCSL, indicate your decision by deleting the provisions above
 * and replace them with the notice and other provisions required by
 * the GPL. If you do not delete the provisions above, a recipient may
 * use your version of this file under the terms of any one of the
 * RPSL, the RCSL or the GPL.
 * 
 * This file is part of the Helix DNA Technology. RealNetworks is the
 * developer of the Original Code and owns the copyrights in the
 * portions it created.
 * 
 * This file, and the files included with this file, is distributed
 * and made available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY
 * KIND, EITHER EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS
 * ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET
 * ENJOYMENT OR NON-INFRINGEMENT.
 * 
 * Technology Compatibility Kit Test Suite(s) Location:
 *    http://www.helixcommunity.org/content/tck
 * 
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */

#ifndef __ihxappinfo_h
#define __ihxappinfo_h



// {225B7FE5-3972-4695-BBE8-E9AFA807C5D0}
DEFINE_GUID(IID_IHXAppInfo,
	    0x225b7fe5, 0x3972, 0x4695,
	    0xbb, 0xe8, 0xe9, 0xaf, 0xa8, 0x7, 0xc5, 0xd0);


DECLARE_INTERFACE_(IHXAppInfo, IUnknown)
{
    STDMETHOD_(const char*, GetName)      (THIS) CONSTMETHOD PURE;
    STDMETHOD(SetName)                    (THIS_ const char* pName) PURE;
    STDMETHOD_(const char*, GetCommand)   (THIS) CONSTMETHOD PURE;
    STDMETHOD(SetCommand)                 (THIS_ const char* pCommand) PURE;
    STDMETHOD_(BOOL, GetCanOpenMultiple)  (THIS) CONSTMETHOD PURE;
    STDMETHOD(SetCanOpenMultiple)         (THIS_ BOOL bCanOpenMultiple) PURE;
    STDMETHOD_(BOOL, GetRequiresTerminal) (THIS) CONSTMETHOD PURE;
    STDMETHOD(SetRequiresTerminal)        (THIS_ BOOL bRequiresTerminal) PURE;
};


#endif /* #ifndef __ihxappinfo_h */
