/* ***** BEGIN LICENSE BLOCK *****
 * Source last modified: $Id: minifmt.h,v 1.5.4.1 2004/07/09 01:58:56 hubbe Exp $
 * 
 * Portions Copyright (c) 1995-2004 RealNetworks, Inc. All Rights Reserved.
 * 
 * The contents of this file, and the files included with this file,
 * are subject to the current version of the RealNetworks Public
 * Source License (the "RPSL") available at
 * http://www.helixcommunity.org/content/rpsl unless you have licensed
 * the file under the current version of the RealNetworks Community
 * Source License (the "RCSL") available at
 * http://www.helixcommunity.org/content/rcsl, in which case the RCSL
 * will apply. You may also obtain the license terms directly from
 * RealNetworks.  You may not use this file except in compliance with
 * the RPSL or, if you have a valid RCSL with RealNetworks applicable
 * to this file, the RCSL.  Please see the applicable RPSL or RCSL for
 * the rights, obligations and limitations governing use of the
 * contents of the file.
 * 
 * Alternatively, the contents of this file may be used under the
 * terms of the GNU General Public License Version 2 or later (the
 * "GPL") in which case the provisions of the GPL are applicable
 * instead of those above. If you wish to allow use of your version of
 * this file only under the terms of the GPL, and not to allow others
 * to use your version of this file under the terms of either the RPSL
 * or RCSL, indicate your decision by deleting the provisions above
 * and replace them with the notice and other provisions required by
 * the GPL. If you do not delete the provisions above, a recipient may
 * use your version of this file under the terms of any one of the
 * RPSL, the RCSL or the GPL.
 * 
 * This file is part of the Helix DNA Technology. RealNetworks is the
 * developer of the Original Code and owns the copyrights in the
 * portions it created.
 * 
 * This file, and the files included with this file, is distributed
 * and made available on an 'AS IS' basis, WITHOUT WARRANTY OF ANY
 * KIND, EITHER EXPRESS OR IMPLIED, AND REALNETWORKS HEREBY DISCLAIMS
 * ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET
 * ENJOYMENT OR NON-INFRINGEMENT.
 * 
 * Technology Compatibility Kit Test Suite(s) Location:
 *    http://www.helixcommunity.org/content/tck
 * 
 * Contributor(s):
 * 
 * ***** END LICENSE BLOCK ***** */

#ifndef _MINIFMT_H_
#define _MINIFMT_H_

#include "hxvsurf.h"
#include "hxtypes.h"

#ifndef MAKEFOURCC
#define MAKEFOURCC(ch0,ch1,ch2,ch3) ( ((ULONG32)((BYTE)(ch0)) | ((ULONG32)((BYTE)(ch1)) << 8) | ((ULONG32)((BYTE)(ch2)) << 16) | ((ULONG32)((BYTE)(ch3)) << 24 )) )
#endif

struct tagFmtEntry;

typedef struct tagFmtEntry
{
    ULONG32 dwFlags;        // indicates valid fields
    ULONG32 dwFourCC;       // FourCC code
    int     cid;
    ULONG32 dwBitCount;     // number of bits/pixel
    ULONG32 nBPP;
    ULONG32 dwBitMask[3];   // RGB bit masks
    struct  tagFmtEntry* pNext;
} FmtEntry;

class CFmtObj
{
public:
    CFmtObj();
    ~CFmtObj();

    int     MakeBitmap (HXBitmapInfo* lpbi,
                        int nBISize, int cid,
                        ULONG32 dwWidth, ULONG32 dwHeight,
                        void* lppe, int nColors);

    
    int     SetBitmapColor(HXBitmapInfo* lpHXbi, int cid);
    int     ImageSize (int cid, ULONG32 dwWidth, ULONG32 dwHeight);
    int     GetBitmapPitch (HXBitmapInfo* lpbi);
    int     GetBitmapColor (HXBitmapInfo* lpHXbi);

protected:
    int     ChkColor (FmtEntry* p,
                      ULONG32 dwFourCC,
                      ULONG32 dwBitCount,
                      ULONG32 *lpBitMask);

    void        CreateFmtList();
    void        DestroyFmtList();
    
    FmtEntry*   CreateFmtEntry( ULONG32 dwFlags,
                                ULONG32 dwFourCC,
                                int     cid,
                                ULONG32 dwBitCount,
                                ULONG32 nBPP,
                                ULONG32 dwBitMask1=0,
                                ULONG32 dwBitMask2=0,
                                ULONG32 dwBitMask3=0
                                );
    FmtEntry*   FindEntry(int cid);

    FmtEntry*   m_pFmtList;
};

#endif //_MINIFMT_H_

